// this file is part of
// markonvert - Fortran unformatted record marker converter
//
// Copyright (C) 2005-2007  Francesco Poli
//
// This work is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 2,
// as published by the Free Software Foundation.
// 
// This work is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this work; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

// #include "config.h"
#include "converter.h"

void
mk::Converter::go()
{
    while(std::cin.peek() != EOF)  // repeat for each record
      {
        std::cin.exceptions(std::ios::eofbit |
                            std::ios::badbit |
                            std::ios::failbit);

        read_start_mark();
        write_mark();
        copy_record();
        read_end_mark();
        write_mark();

        std::cin.exceptions(std::ios::goodbit);
      }
}

void
mk::Converter::copy_record()
{
    char byte;
    for (int32 i = 0; i < record_len; ++i)
      {
        std::cin.get(byte);
        std::cout.put(byte);
      }
}

