// this file is part of
// markonvert - Fortran unformatted record marker converter
//
// Copyright (C) 2005-2007  Francesco Poli
//
// This work is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License, version 2,
// as published by the Free Software Foundation.
// 
// This work is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this work; if not, write to the Free Software Foundation, Inc.,
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

#ifndef MK_TO64WRITER_H
#define MK_TO64WRITER_H

#include "converter.h"

namespace mk
{
    // class for writing to a 64 bit marker file
    class To64Writer : public virtual Converter
      {
        protected:
            virtual void write_mark()
              {
                // write record start/end marker to stdout
                int32 zero = 0;
                std::cout.write(reinterpret_cast<char*>(&record_len),
                                sizeof(int32));
                std::cout.write(reinterpret_cast<char*>(&zero),
                                sizeof(int32));
              }
      };

    /* works for little endian data on little endian machines!
       TODO: the general case should be addressed... */
}

#endif // not MK_TO64WRITER_H
